

#ifndef _DIRBAR_HH_
#define _DIRBAR_HH_

#include <qpushbt.h>
#include <qdir.h>
#include <qlined.h>

#include "icon.hh"

class QLineEdit ;

class DButton : public QPushButton {
  
  Q_OBJECT ;

  char *name ;

protected:
  void mouseReleaseEvent (QMouseEvent *) { 
    update () ; emit clicked (name) ; }
  
public:
  DButton (QWidget *parent, const char *c, int len) 
    : QPushButton (parent) 
    {
      name = new char[ len + 1 ] ;
      strncpy (name, c, len) ;
      name[len] = '\0' ;
    }
  
  signals:
 
 void clicked (const char *c) ;
    
  
} ;


class DirectoryBar : public QWidget {

  Q_OBJECT ;

  QDir dir ;
  QList<DButton> *blist ;
  QLineEdit *dirName ;
  Icon *logo ;

  int saveW ; // kludge

  char * filter ;
  void reset () ;

  private slots:
  void parse () ;
  void parse (const char *) ;
public:
  
  DirectoryBar (const QDir &d, QWidget *parent=0) ;

  void up () ;
  void paintEvent (QPaintEvent *) ;
  void resizeEvent (QResizeEvent *) ;
  
  void indicateDragDrop (const QPoint &) ;
  void drag_drop_happened (const char *) ;
  void unHighlightDragDrop () {
    if (logo->is_drag_drop ()) {
      logo->set_drag_drop (false) ;
      repaint() ;
    }
  }

  signals:
  void dirChanged (const QDir&) ;

 public slots:
  void reset (const QDir &d) ;

} ;

#endif // _DIRBAR_HH_
